<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDatiSalientiMensile ArrayType
 * @subpackage Arrays
 */
class ArrayOfDatiSalientiMensile extends AbstractStructArrayBase
{
    /**
     * The DatiSalientiMensile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DatiSalientiMensile[]
     */
    public $DatiSalientiMensile;
    /**
     * Constructor method for ArrayOfDatiSalientiMensile
     * @uses ArrayOfDatiSalientiMensile::setDatiSalientiMensile()
     * @param \StructType\DatiSalientiMensile[] $datiSalientiMensile
     */
    public function __construct(array $datiSalientiMensile = array())
    {
        $this
            ->setDatiSalientiMensile($datiSalientiMensile);
    }
    /**
     * Get DatiSalientiMensile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DatiSalientiMensile[]|null
     */
    public function getDatiSalientiMensile()
    {
        return isset($this->DatiSalientiMensile) ? $this->DatiSalientiMensile : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDatiSalientiMensile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDatiSalientiMensile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDatiSalientiMensileForArrayConstraintsFromSetDatiSalientiMensile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDatiSalientiMensileDatiSalientiMensileItem) {
            // validation for constraint: itemType
            if (!$arrayOfDatiSalientiMensileDatiSalientiMensileItem instanceof \StructType\DatiSalientiMensile) {
                $invalidValues[] = is_object($arrayOfDatiSalientiMensileDatiSalientiMensileItem) ? get_class($arrayOfDatiSalientiMensileDatiSalientiMensileItem) : sprintf('%s(%s)', gettype($arrayOfDatiSalientiMensileDatiSalientiMensileItem), var_export($arrayOfDatiSalientiMensileDatiSalientiMensileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DatiSalientiMensile property can only contain items of type \StructType\DatiSalientiMensile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DatiSalientiMensile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DatiSalientiMensile[] $datiSalientiMensile
     * @return \ArrayType\ArrayOfDatiSalientiMensile
     */
    public function setDatiSalientiMensile(array $datiSalientiMensile = array())
    {
        // validation for constraint: array
        if ('' !== ($datiSalientiMensileArrayErrorMessage = self::validateDatiSalientiMensileForArrayConstraintsFromSetDatiSalientiMensile($datiSalientiMensile))) {
            throw new \InvalidArgumentException($datiSalientiMensileArrayErrorMessage, __LINE__);
        }
        if (is_null($datiSalientiMensile) || (is_array($datiSalientiMensile) && empty($datiSalientiMensile))) {
            unset($this->DatiSalientiMensile);
        } else {
            $this->DatiSalientiMensile = $datiSalientiMensile;
        }
        return $this;
    }
    /**
     * Add item to DatiSalientiMensile value
     * @throws \InvalidArgumentException
     * @param \StructType\DatiSalientiMensile $item
     * @return \ArrayType\ArrayOfDatiSalientiMensile
     */
    public function addToDatiSalientiMensile(\StructType\DatiSalientiMensile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DatiSalientiMensile) {
            throw new \InvalidArgumentException(sprintf('The DatiSalientiMensile property can only contain items of type \StructType\DatiSalientiMensile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DatiSalientiMensile[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DatiSalientiMensile|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DatiSalientiMensile|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DatiSalientiMensile|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DatiSalientiMensile|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DatiSalientiMensile|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DatiSalientiMensile
     */
    public function getAttributeName()
    {
        return 'DatiSalientiMensile';
    }
}
