<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrenotazioneBean ArrayType
 * @subpackage Arrays
 */
class ArrayOfPrenotazioneBean extends AbstractStructArrayBase
{
    /**
     * The prenotazione
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PrenotazioneBean[]
     */
    public $prenotazione;
    /**
     * Constructor method for ArrayOfPrenotazioneBean
     * @uses ArrayOfPrenotazioneBean::setPrenotazione()
     * @param \StructType\PrenotazioneBean[] $prenotazione
     */
    public function __construct(array $prenotazione = array())
    {
        $this
            ->setPrenotazione($prenotazione);
    }
    /**
     * Get prenotazione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PrenotazioneBean[]|null
     */
    public function getPrenotazione()
    {
        return isset($this->prenotazione) ? $this->prenotazione : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrenotazione method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrenotazione method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrenotazioneForArrayConstraintsFromSetPrenotazione(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrenotazioneBeanPrenotazioneItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrenotazioneBeanPrenotazioneItem instanceof \StructType\PrenotazioneBean) {
                $invalidValues[] = is_object($arrayOfPrenotazioneBeanPrenotazioneItem) ? get_class($arrayOfPrenotazioneBeanPrenotazioneItem) : sprintf('%s(%s)', gettype($arrayOfPrenotazioneBeanPrenotazioneItem), var_export($arrayOfPrenotazioneBeanPrenotazioneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The prenotazione property can only contain items of type \StructType\PrenotazioneBean, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set prenotazione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PrenotazioneBean[] $prenotazione
     * @return \ArrayType\ArrayOfPrenotazioneBean
     */
    public function setPrenotazione(array $prenotazione = array())
    {
        // validation for constraint: array
        if ('' !== ($prenotazioneArrayErrorMessage = self::validatePrenotazioneForArrayConstraintsFromSetPrenotazione($prenotazione))) {
            throw new \InvalidArgumentException($prenotazioneArrayErrorMessage, __LINE__);
        }
        if (is_null($prenotazione) || (is_array($prenotazione) && empty($prenotazione))) {
            unset($this->prenotazione);
        } else {
            $this->prenotazione = $prenotazione;
        }
        return $this;
    }
    /**
     * Add item to prenotazione value
     * @throws \InvalidArgumentException
     * @param \StructType\PrenotazioneBean $item
     * @return \ArrayType\ArrayOfPrenotazioneBean
     */
    public function addToPrenotazione(\StructType\PrenotazioneBean $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PrenotazioneBean) {
            throw new \InvalidArgumentException(sprintf('The prenotazione property can only contain items of type \StructType\PrenotazioneBean, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->prenotazione[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PrenotazioneBean|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PrenotazioneBean|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PrenotazioneBean|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PrenotazioneBean|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PrenotazioneBean|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string prenotazione
     */
    public function getAttributeName()
    {
        return 'prenotazione';
    }
}
