<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRisultatoGiornoV1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfRisultatoGiornoV1 extends AbstractStructArrayBase
{
    /**
     * The risultatiGiorno
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RisultatoGiornoV1[]
     */
    public $risultatiGiorno;
    /**
     * Constructor method for ArrayOfRisultatoGiornoV1
     * @uses ArrayOfRisultatoGiornoV1::setRisultatiGiorno()
     * @param \StructType\RisultatoGiornoV1[] $risultatiGiorno
     */
    public function __construct(array $risultatiGiorno = array())
    {
        $this
            ->setRisultatiGiorno($risultatiGiorno);
    }
    /**
     * Get risultatiGiorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RisultatoGiornoV1[]|null
     */
    public function getRisultatiGiorno()
    {
        return isset($this->risultatiGiorno) ? $this->risultatiGiorno : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRisultatiGiorno method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRisultatiGiorno method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRisultatiGiornoForArrayConstraintsFromSetRisultatiGiorno(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRisultatoGiornoV1RisultatiGiornoItem) {
            // validation for constraint: itemType
            if (!$arrayOfRisultatoGiornoV1RisultatiGiornoItem instanceof \StructType\RisultatoGiornoV1) {
                $invalidValues[] = is_object($arrayOfRisultatoGiornoV1RisultatiGiornoItem) ? get_class($arrayOfRisultatoGiornoV1RisultatiGiornoItem) : sprintf('%s(%s)', gettype($arrayOfRisultatoGiornoV1RisultatiGiornoItem), var_export($arrayOfRisultatoGiornoV1RisultatiGiornoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The risultatiGiorno property can only contain items of type \StructType\RisultatoGiornoV1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set risultatiGiorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoGiornoV1[] $risultatiGiorno
     * @return \ArrayType\ArrayOfRisultatoGiornoV1
     */
    public function setRisultatiGiorno(array $risultatiGiorno = array())
    {
        // validation for constraint: array
        if ('' !== ($risultatiGiornoArrayErrorMessage = self::validateRisultatiGiornoForArrayConstraintsFromSetRisultatiGiorno($risultatiGiorno))) {
            throw new \InvalidArgumentException($risultatiGiornoArrayErrorMessage, __LINE__);
        }
        if (is_null($risultatiGiorno) || (is_array($risultatiGiorno) && empty($risultatiGiorno))) {
            unset($this->risultatiGiorno);
        } else {
            $this->risultatiGiorno = $risultatiGiorno;
        }
        return $this;
    }
    /**
     * Add item to risultatiGiorno value
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoGiornoV1 $item
     * @return \ArrayType\ArrayOfRisultatoGiornoV1
     */
    public function addToRisultatiGiorno(\StructType\RisultatoGiornoV1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RisultatoGiornoV1) {
            throw new \InvalidArgumentException(sprintf('The risultatiGiorno property can only contain items of type \StructType\RisultatoGiornoV1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->risultatiGiorno[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RisultatoGiornoV1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RisultatoGiornoV1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RisultatoGiornoV1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RisultatoGiornoV1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RisultatoGiornoV1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string risultatiGiorno
     */
    public function getAttributeName()
    {
        return 'risultatiGiorno';
    }
}
