<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRisultatoV13 ArrayType
 * @subpackage Arrays
 */
class ArrayOfRisultatoV13 extends AbstractStructArrayBase
{
    /**
     * The eliminazione
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RisultatoV1[]
     */
    public $eliminazione;
    /**
     * Constructor method for ArrayOfRisultatoV13
     * @uses ArrayOfRisultatoV13::setEliminazione()
     * @param \StructType\RisultatoV1[] $eliminazione
     */
    public function __construct(array $eliminazione = array())
    {
        $this
            ->setEliminazione($eliminazione);
    }
    /**
     * Get eliminazione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RisultatoV1[]|null
     */
    public function getEliminazione()
    {
        return isset($this->eliminazione) ? $this->eliminazione : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEliminazione method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEliminazione method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEliminazioneForArrayConstraintsFromSetEliminazione(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRisultatoV13EliminazioneItem) {
            // validation for constraint: itemType
            if (!$arrayOfRisultatoV13EliminazioneItem instanceof \StructType\RisultatoV1) {
                $invalidValues[] = is_object($arrayOfRisultatoV13EliminazioneItem) ? get_class($arrayOfRisultatoV13EliminazioneItem) : sprintf('%s(%s)', gettype($arrayOfRisultatoV13EliminazioneItem), var_export($arrayOfRisultatoV13EliminazioneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The eliminazione property can only contain items of type \StructType\RisultatoV1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set eliminazione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoV1[] $eliminazione
     * @return \ArrayType\ArrayOfRisultatoV13
     */
    public function setEliminazione(array $eliminazione = array())
    {
        // validation for constraint: array
        if ('' !== ($eliminazioneArrayErrorMessage = self::validateEliminazioneForArrayConstraintsFromSetEliminazione($eliminazione))) {
            throw new \InvalidArgumentException($eliminazioneArrayErrorMessage, __LINE__);
        }
        if (is_null($eliminazione) || (is_array($eliminazione) && empty($eliminazione))) {
            unset($this->eliminazione);
        } else {
            $this->eliminazione = $eliminazione;
        }
        return $this;
    }
    /**
     * Add item to eliminazione value
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoV1 $item
     * @return \ArrayType\ArrayOfRisultatoV13
     */
    public function addToEliminazione(\StructType\RisultatoV1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RisultatoV1) {
            throw new \InvalidArgumentException(sprintf('The eliminazione property can only contain items of type \StructType\RisultatoV1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->eliminazione[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RisultatoV1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RisultatoV1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RisultatoV1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RisultatoV1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RisultatoV1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string eliminazione
     */
    public function getAttributeName()
    {
        return 'eliminazione';
    }
}
