<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for movimentoBeanV1 StructType
 * @subpackage Structs
 */
class MovimentoBeanV1 extends AbstractStructBase
{
    /**
     * The arrivi
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \ArrayType\ArrayOfArrivoBeanV1
     */
    public $arrivi;
    /**
     * The partenze
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \ArrayType\ArrayOfPartenzaBeanV1
     */
    public $partenze;
    /**
     * The prenotazioni
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \ArrayType\ArrayOfPrenotazioneBeanV1
     */
    public $prenotazioni;
    /**
     * The rettifiche
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \ArrayType\ArrayOfEliminazioneBeanV1
     */
    public $rettifiche;
    /**
     * The data
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $data;
    /**
     * The struttura
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\StrutturaBeanV1
     */
    public $struttura;
    /**
     * Constructor method for movimentoBeanV1
     * @uses MovimentoBeanV1::setArrivi()
     * @uses MovimentoBeanV1::setPartenze()
     * @uses MovimentoBeanV1::setPrenotazioni()
     * @uses MovimentoBeanV1::setRettifiche()
     * @uses MovimentoBeanV1::setData()
     * @uses MovimentoBeanV1::setStruttura()
     * @param \ArrayType\ArrayOfArrivoBeanV1 $arrivi
     * @param \ArrayType\ArrayOfPartenzaBeanV1 $partenze
     * @param \ArrayType\ArrayOfPrenotazioneBeanV1 $prenotazioni
     * @param \ArrayType\ArrayOfEliminazioneBeanV1 $rettifiche
     * @param string $data
     * @param \StructType\StrutturaBeanV1 $struttura
     */
    public function __construct(\ArrayType\ArrayOfArrivoBeanV1 $arrivi = null, \ArrayType\ArrayOfPartenzaBeanV1 $partenze = null, \ArrayType\ArrayOfPrenotazioneBeanV1 $prenotazioni = null, \ArrayType\ArrayOfEliminazioneBeanV1 $rettifiche = null, $data = null, \StructType\StrutturaBeanV1 $struttura = null)
    {
        $this
            ->setArrivi($arrivi)
            ->setPartenze($partenze)
            ->setPrenotazioni($prenotazioni)
            ->setRettifiche($rettifiche)
            ->setData($data)
            ->setStruttura($struttura);
    }
    /**
     * Get arrivi value
     * @return \ArrayType\ArrayOfArrivoBeanV1
     */
    public function getArrivi()
    {
        return $this->arrivi;
    }
    /**
     * Set arrivi value
     * @param \ArrayType\ArrayOfArrivoBeanV1 $arrivi
     * @return \StructType\MovimentoBeanV1
     */
    public function setArrivi(\ArrayType\ArrayOfArrivoBeanV1 $arrivi = null)
    {
        $this->arrivi = $arrivi;
        return $this;
    }
    /**
     * Get partenze value
     * @return \ArrayType\ArrayOfPartenzaBeanV1
     */
    public function getPartenze()
    {
        return $this->partenze;
    }
    /**
     * Set partenze value
     * @param \ArrayType\ArrayOfPartenzaBeanV1 $partenze
     * @return \StructType\MovimentoBeanV1
     */
    public function setPartenze(\ArrayType\ArrayOfPartenzaBeanV1 $partenze = null)
    {
        $this->partenze = $partenze;
        return $this;
    }
    /**
     * Get prenotazioni value
     * @return \ArrayType\ArrayOfPrenotazioneBeanV1
     */
    public function getPrenotazioni()
    {
        return $this->prenotazioni;
    }
    /**
     * Set prenotazioni value
     * @param \ArrayType\ArrayOfPrenotazioneBeanV1 $prenotazioni
     * @return \StructType\MovimentoBeanV1
     */
    public function setPrenotazioni(\ArrayType\ArrayOfPrenotazioneBeanV1 $prenotazioni = null)
    {
        $this->prenotazioni = $prenotazioni;
        return $this;
    }
    /**
     * Get rettifiche value
     * @return \ArrayType\ArrayOfEliminazioneBeanV1
     */
    public function getRettifiche()
    {
        return $this->rettifiche;
    }
    /**
     * Set rettifiche value
     * @param \ArrayType\ArrayOfEliminazioneBeanV1 $rettifiche
     * @return \StructType\MovimentoBeanV1
     */
    public function setRettifiche(\ArrayType\ArrayOfEliminazioneBeanV1 $rettifiche = null)
    {
        $this->rettifiche = $rettifiche;
        return $this;
    }
    /**
     * Get data value
     * @return string|null
     */
    public function getData()
    {
        return $this->data;
    }
    /**
     * Set data value
     * @param string $data
     * @return \StructType\MovimentoBeanV1
     */
    public function setData($data = null)
    {
        // validation for constraint: string
        if (!is_null($data) && !is_string($data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($data, true), gettype($data)), __LINE__);
        }
        $this->data = $data;
        return $this;
    }
    /**
     * Get struttura value
     * @return \StructType\StrutturaBeanV1|null
     */
    public function getStruttura()
    {
        return $this->struttura;
    }
    /**
     * Set struttura value
     * @param \StructType\StrutturaBeanV1 $struttura
     * @return \StructType\MovimentoBeanV1
     */
    public function setStruttura(\StructType\StrutturaBeanV1 $struttura = null)
    {
        $this->struttura = $struttura;
        return $this;
    }
}
