<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for risultato StructType
 * @subpackage Structs
 */
class Risultato extends AbstractStructBase
{
    /**
     * The successo
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $successo;
    /**
     * The errore
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $errore;
    /**
     * The idswh
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $idswh;
    /**
     * Constructor method for risultato
     * @uses Risultato::setSuccesso()
     * @uses Risultato::setErrore()
     * @uses Risultato::setIdswh()
     * @param bool $successo
     * @param string $errore
     * @param string $idswh
     */
    public function __construct($successo = null, $errore = null, $idswh = null)
    {
        $this
            ->setSuccesso($successo)
            ->setErrore($errore)
            ->setIdswh($idswh);
    }
    /**
     * Get successo value
     * @return bool
     */
    public function getSuccesso()
    {
        return $this->successo;
    }
    /**
     * Set successo value
     * @param bool $successo
     * @return \StructType\Risultato
     */
    public function setSuccesso($successo = null)
    {
        // validation for constraint: boolean
        if (!is_null($successo) && !is_bool($successo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successo, true), gettype($successo)), __LINE__);
        }
        $this->successo = $successo;
        return $this;
    }
    /**
     * Get errore value
     * @return string
     */
    public function getErrore()
    {
        return $this->errore;
    }
    /**
     * Set errore value
     * @param string $errore
     * @return \StructType\Risultato
     */
    public function setErrore($errore = null)
    {
        // validation for constraint: string
        if (!is_null($errore) && !is_string($errore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errore, true), gettype($errore)), __LINE__);
        }
        $this->errore = $errore;
        return $this;
    }
    /**
     * Get idswh value
     * @return string|null
     */
    public function getIdswh()
    {
        return $this->idswh;
    }
    /**
     * Set idswh value
     * @param string $idswh
     * @return \StructType\Risultato
     */
    public function setIdswh($idswh = null)
    {
        // validation for constraint: string
        if (!is_null($idswh) && !is_string($idswh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idswh, true), gettype($idswh)), __LINE__);
        }
        $this->idswh = $idswh;
        return $this;
    }
}
