<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceMensile_Response StructType
 * @subpackage Structs
 */
class ServiceMensile_Response extends AbstractStructBase
{
    /**
     * The esito
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $esito;
    /**
     * The tracciatoMensile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDatiSalientiMensile
     */
    public $tracciatoMensile;
    /**
     * The errorcode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errorcode;
    /**
     * The errormessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errormessage;
    /**
     * Constructor method for ServiceMensile_Response
     * @uses ServiceMensile_Response::setEsito()
     * @uses ServiceMensile_Response::setTracciatoMensile()
     * @uses ServiceMensile_Response::setErrorcode()
     * @uses ServiceMensile_Response::setErrormessage()
     * @param string $esito
     * @param \ArrayType\ArrayOfDatiSalientiMensile $tracciatoMensile
     * @param string $errorcode
     * @param string $errormessage
     */
    public function __construct($esito = null, \ArrayType\ArrayOfDatiSalientiMensile $tracciatoMensile = null, $errorcode = null, $errormessage = null)
    {
        $this
            ->setEsito($esito)
            ->setTracciatoMensile($tracciatoMensile)
            ->setErrorcode($errorcode)
            ->setErrormessage($errormessage);
    }
    /**
     * Get esito value
     * @return string|null
     */
    public function getEsito()
    {
        return $this->esito;
    }
    /**
     * Set esito value
     * @param string $esito
     * @return \StructType\ServiceMensile_Response
     */
    public function setEsito($esito = null)
    {
        // validation for constraint: string
        if (!is_null($esito) && !is_string($esito)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($esito, true), gettype($esito)), __LINE__);
        }
        $this->esito = $esito;
        return $this;
    }
    /**
     * Get tracciatoMensile value
     * @return \ArrayType\ArrayOfDatiSalientiMensile|null
     */
    public function getTracciatoMensile()
    {
        return $this->tracciatoMensile;
    }
    /**
     * Set tracciatoMensile value
     * @param \ArrayType\ArrayOfDatiSalientiMensile $tracciatoMensile
     * @return \StructType\ServiceMensile_Response
     */
    public function setTracciatoMensile(\ArrayType\ArrayOfDatiSalientiMensile $tracciatoMensile = null)
    {
        $this->tracciatoMensile = $tracciatoMensile;
        return $this;
    }
    /**
     * Get errorcode value
     * @return string|null
     */
    public function getErrorcode()
    {
        return $this->errorcode;
    }
    /**
     * Set errorcode value
     * @param string $errorcode
     * @return \StructType\ServiceMensile_Response
     */
    public function setErrorcode($errorcode = null)
    {
        // validation for constraint: string
        if (!is_null($errorcode) && !is_string($errorcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorcode, true), gettype($errorcode)), __LINE__);
        }
        $this->errorcode = $errorcode;
        return $this;
    }
    /**
     * Get errormessage value
     * @return string|null
     */
    public function getErrormessage()
    {
        return $this->errormessage;
    }
    /**
     * Set errormessage value
     * @param string $errormessage
     * @return \StructType\ServiceMensile_Response
     */
    public function setErrormessage($errormessage = null)
    {
        // validation for constraint: string
        if (!is_null($errormessage) && !is_string($errormessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errormessage, true), gettype($errormessage)), __LINE__);
        }
        $this->errormessage = $errormessage;
        return $this;
    }
}
